GNU bug report logs - #46494
28.0.50; [native-comp] Problems with async background compile

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Andy Moreton <andrewjmoreton@HIDDEN>; dated Sat, 13 Feb 2021 16:59:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 22 Feb 2021 19:51:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 22 14:51:19 2021
Received: from localhost ([127.0.0.1]:57611 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEHEl-0006r7-Ab
	for submit <at> debbugs.gnu.org; Mon, 22 Feb 2021 14:51:19 -0500
Received: from mx.sdf.org ([205.166.94.24]:64604)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lEHEi-0006qt-Ep
 for 46494 <at> debbugs.gnu.org; Mon, 22 Feb 2021 14:51:18 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11MJpEH3018362
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Mon, 22 Feb 2021 19:51:14 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
 <xjfo8gdktfb.fsf@HIDDEN> <83mtvwwzkq.fsf@HIDDEN>
Date: Mon, 22 Feb 2021 19:51:14 +0000
In-Reply-To: <83mtvwwzkq.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 22 Feb
 2021 05:28:37 +0200")
Message-ID: <xjfwnuzkhjh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> We use `paths' in `native-compile-async' and `native--compile-async' as
>> arg name.  This can be either a file, a list of file or a list of
>> directories.  What would be the suggested name for something like that?
>
> "files"?

Well.. fair :D 81b1013555 does that.

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 22 Feb 2021 03:29:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 21 22:29:03 2021
Received: from localhost ([127.0.0.1]:55334 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lE1u8-00032i-QF
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2021 22:29:02 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33288)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lE1u6-00032U-9J
 for 46494 <at> debbugs.gnu.org; Sun, 21 Feb 2021 22:29:00 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45563)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lE1tx-0004yi-SJ; Sun, 21 Feb 2021 22:28:49 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1199
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lE1tx-0007SB-5E; Sun, 21 Feb 2021 22:28:49 -0500
Date: Mon, 22 Feb 2021 05:28:37 +0200
Message-Id: <83mtvwwzkq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfo8gdktfb.fsf@HIDDEN> (message from Andrea Corallo on Sun, 21
 Feb 2021 21:22:16 +0000)
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN> <xjfo8gdktfb.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
> Date: Sun, 21 Feb 2021 21:22:16 +0000
> 
> >   . How does libgccjit handle the case that its process is exiting?
> >     Does it have any atexit handlers or static destructors?  IOW, how
> >     does it ensure its own subprocesses, like gas etc. are terminated?
> 
> No precise idea about sorry.  Perhaps the best place to ask and discuss
> that would be jit@HIDDEN?

If we need to, perhaps we should.

> >   . When we invoke Emacs in a subprocess to do the async compilation,
> >     do we specify that it should be killed without query?  I don't see
> >     this in the code (did I miss it?), but if we don't, then exiting
> >     Emacs will ask the user whether to kill the subprocesses -- does
> >     it?
> 
> Yes it does, should we change this?

no, I don't think so.  It's just that no one here mentioned that
question, so I assumed it isn't being asked.

> > P.S. Andrea, I see you use "path" in comp.el (and perhaps elsewhere)
> > to mean "file name", but the GNU Coding Standards frown on using this
> > for anything other than PATH-style directory lists.  So this should at
> > some point be replaced with "file name".
> 
> da4da88c76 fix one case of this.
> 
> We use `paths' in `native-compile-async' and `native--compile-async' as
> arg name.  This can be either a file, a list of file or a list of
> directories.  What would be the suggested name for something like that?

"files"?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 21 Feb 2021 21:22:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 21 16:22:22 2021
Received: from localhost ([127.0.0.1]:55073 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDwBJ-0002r2-O4
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2021 16:22:22 -0500
Received: from mx.sdf.org ([205.166.94.24]:64129)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lDwBF-0002qr-QZ
 for 46494 <at> debbugs.gnu.org; Sun, 21 Feb 2021 16:22:20 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11LLMGrH009120
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 21 Feb 2021 21:22:17 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
Date: Sun, 21 Feb 2021 21:22:16 +0000
In-Reply-To: <834ki710ug.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 20 Feb
 2021 12:37:43 +0200")
Message-ID: <xjfo8gdktfb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
>> Date: Sun, 14 Feb 2021 18:28:02 +0000
>> 
>> >> > c) Quitting emacs when async compilation processes are running sometimes
>> >> >    causes crashes in the compile processes, which show the emacs abort
>> >> >    dialog (once for each async process). The dialogs disappear after a
>> >> >    short delay (presumably due to the parent emacs having exited).
>> >> 
>> >> Mmmh, I guess this is a Windows specific behavior.  Is there a specific
>> >> way to shut-down child processes we would use on Windows not to get
>> >> this error?
>> >
>> > Andrea, can you point me to the place where we interrupt async
>> > compilations when Emacs exits?  Is that just a normal delete-process,
>> > or do we do something else, like sending a signal?  Also, does the
>> > Emacs subprocess invoked to perform async compilation spawn further
>> > child processes, or is everything happening inside a single Emacs
>> > process?
>> 
>> Hi Eli,
>> 
>> we have no special handling for closing async compilation processes,
>> they should be closed as all child processes started by Emacs are.
>> 
>> In the child process we do not spawn directly any other process, but
>> libgccjit might do it (ex to call gas).
>
> OK, I've reviewed the code which kills subprocesses when Emacs is shut
> down, and I have some questions:
>
>   . How does libgccjit handle the case that its process is exiting?
>     Does it have any atexit handlers or static destructors?  IOW, how
>     does it ensure its own subprocesses, like gas etc. are terminated?

No precise idea about sorry.  Perhaps the best place to ask and discuss
that would be jit@HIDDEN?

>   . When we invoke Emacs in a subprocess to do the async compilation,
>     do we specify that it should be killed without query?  I don't see
>     this in the code (did I miss it?), but if we don't, then exiting
>     Emacs will ask the user whether to kill the subprocesses -- does
>     it?

Yes it does, should we change this?

> Andy, if instead if exiting Emacs, you use signal-process, like this:
>
>   M-: (signal-process PROC-ID 'SIGHUP) RET
>
> (where PROC-ID is the process ID of the Emacs subprocess running the
> native compilation), do you see the same crash, or does the subprocess
> exit cleanly?  To see the PROC-ID, you can use the Task manager or the
> 'pslist' command from the PsTools suite.
>
> Thanks.
>
> P.S. Andrea, I see you use "path" in comp.el (and perhaps elsewhere)
> to mean "file name", but the GNU Coding Standards frown on using this
> for anything other than PATH-style directory lists.  So this should at
> some point be replaced with "file name".

da4da88c76 fix one case of this.

We use `paths' in `native-compile-async' and `native--compile-async' as
arg name.  This can be either a file, a list of file or a list of
directories.  What would be the suggested name for something like that?

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 20 Feb 2021 17:38:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 12:38:14 2021
Received: from localhost ([127.0.0.1]:52767 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDWCr-0007Yk-SL
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 12:38:14 -0500
Received: from eggs.gnu.org ([209.51.188.92]:44088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lDWCq-0007YY-Db
 for 46494 <at> debbugs.gnu.org; Sat, 20 Feb 2021 12:38:12 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:48117)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lDWCl-0002xA-6K; Sat, 20 Feb 2021 12:38:07 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3116
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lDWCk-0008I8-Ch; Sat, 20 Feb 2021 12:38:06 -0500
Date: Sat, 20 Feb 2021 19:37:50 +0200
Message-Id: <834ki6zlld.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <86y2fi7ikf.fsf@HIDDEN> (message from Andy Moreton on Sat, 20
 Feb 2021 17:30:40 +0000)
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
 <868s7jym8t.fsf@HIDDEN> <83wnv2zypz.fsf@HIDDEN>
 <864ki68zg9.fsf@HIDDEN> <83a6ryznlj.fsf@HIDDEN> <86y2fi7ikf.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Sat, 20 Feb 2021 17:30:40 +0000
> 
> > Great, thanks for trying this.  So at the very least we have a
> > workaround, if not the solution.
> 
> Yes. It also seemed faster, in that I had to be quicker at entering
> process IDs to send a single before the subprocess exited normally.

Maybe because when w32-start-process-share-console is nil, we tell
CreateProcess to create a new console for the sub-process, and that
takes more time for the OS.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Feb 2021 17:30:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 12:30:56 2021
Received: from localhost ([127.0.0.1]:52763 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDW5o-0007Ny-0X
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 12:30:56 -0500
Received: from lists.gnu.org ([209.51.188.17]:45494)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDW5k-0007Np-4f
 for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 12:30:54 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:60690)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDW5h-0006ns-Ix
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 12:30:51 -0500
Received: from ciao.gmane.io ([116.202.254.214]:42404)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDW5f-0008Ur-9Z
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 12:30:48 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDW5c-0006QJ-Qp
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 18:30:44 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
Date: Sat, 20 Feb 2021 17:30:40 +0000
Message-ID: <86y2fi7ikf.fsf@HIDDEN>
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
 <868s7jym8t.fsf@HIDDEN> <83wnv2zypz.fsf@HIDDEN>
 <864ki68zg9.fsf@HIDDEN> <83a6ryznlj.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:5CkcHylP5Trayl5mu/zUftAcxsI=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sat 20 Feb 2021, Eli Zaretskii wrote:

>> From: Andy Moreton <andrewjmoreton@HIDDEN>
>> Date: Sat, 20 Feb 2021 16:40:38 +0000
>> 
>> Using "(w32-start-process-share-console t)" with 'SIGHUP seemed to work
>> without triggering the abort dialog, and killing emacs with async
>> processes running also did, not trigger the aborts.
>
> Great, thanks for trying this.  So at the very least we have a
> workaround, if not the solution.

Yes. It also seemed faster, in that I had to be quicker at entering
process IDs to send a single before the subprocess exited normally.

> FTR, setting w32-start-process-share-console non-nil causes the
> subprocess to start a new process group, and sending SIGHUP to the
> inferior Emacs then kills it via the TerminateProcess API, whereas
> when w32-start-process-share-console is nil (the default), we try
> being nice, and send it the WM_CLOSE message.

If being polite does not work, then we will need the more forceful
approach.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 20 Feb 2021 16:54:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 11:54:54 2021
Received: from localhost ([127.0.0.1]:52714 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDVWw-0006M5-Em
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 11:54:54 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36406)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lDVWv-0006Lr-3Q
 for 46494 <at> debbugs.gnu.org; Sat, 20 Feb 2021 11:54:53 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47140)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lDVWp-0003uG-Rx; Sat, 20 Feb 2021 11:54:47 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4437
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lDVWp-0000HH-7P; Sat, 20 Feb 2021 11:54:47 -0500
Date: Sat, 20 Feb 2021 18:54:32 +0200
Message-Id: <83a6ryznlj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <864ki68zg9.fsf@HIDDEN> (message from Andy Moreton on Sat, 20
 Feb 2021 16:40:38 +0000)
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
 <868s7jym8t.fsf@HIDDEN> <83wnv2zypz.fsf@HIDDEN> <864ki68zg9.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Sat, 20 Feb 2021 16:40:38 +0000
> 
> Using "(w32-start-process-share-console t)" with 'SIGHUP seemed to work
> without triggering the abort dialog, and killing emacs with async
> processes running also did, not trigger the aborts.

Great, thanks for trying this.  So at the very least we have a
workaround, if not the solution.

FTR, setting w32-start-process-share-console non-nil causes the
subprocess to start a new process group, and sending SIGHUP to the
inferior Emacs then kills it via the TerminateProcess API, whereas
when w32-start-process-share-console is nil (the default), we try
being nice, and send it the WM_CLOSE message.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Feb 2021 16:40:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 11:40:50 2021
Received: from localhost ([127.0.0.1]:52698 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDVJK-00061s-2x
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 11:40:50 -0500
Received: from lists.gnu.org ([209.51.188.17]:46160)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDVJH-00061k-3l
 for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 11:40:48 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:51512)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDVJG-0006jL-Sk
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 11:40:46 -0500
Received: from ciao.gmane.io ([116.202.254.214]:36136)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDVJF-0005hW-Gl
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 11:40:46 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDVJE-0003KT-0q
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 17:40:44 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
Date: Sat, 20 Feb 2021 16:40:38 +0000
Message-ID: <864ki68zg9.fsf@HIDDEN>
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
 <868s7jym8t.fsf@HIDDEN> <83wnv2zypz.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:qiOjXqvbEzDNWrF2ZnBBdxbJHqQ=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sat 20 Feb 2021, Eli Zaretskii wrote:

>> From: Andy Moreton <andrewjmoreton@HIDDEN>
>> Date: Sat, 20 Feb 2021 12:09:06 +0000
>> 
>> >   M-: (signal-process PROC-ID 'SIGHUP) RET
>> >
>> > (where PROC-ID is the process ID of the Emacs subprocess running the
>> > native compilation), do you see the same crash, or does the subprocess
>> > exit cleanly?  To see the PROC-ID, you can use the Task manager or the
>> > 'pslist' command from the PsTools suite.
>> 
>> I tried that by adding binding this to a key:
>>   (defun signal-hup (proc)
>>     (interactive "nProcess: ")
>>     (signal-process proc 'SIGHUP))
>> 
>> On a x86_64-w64-mingw32 build, sending SIGHUP to a compilation
>> subprocess results in the emacs abort dialog being shown briefly and
>> then disappearing (without user interaction). That dialog should require
>> pressing a button to dismiss it.
>
> I think if the process dies or exits, the dialog is closed.
>
> So, since you seem to be able to reproduce this with a simpler setup,
> please try these:
>
>   . repeat the experiment using 'SIGINT and 'SIGBREAK instead of
>     'SIGHUP
>   . repeat the experiment with w32-start-process-share-console set to
>     a non-nil value (both with SIGHUP and the other 2 SIG* signals)
>
> I'd be interested to know whether the results are different.

Using 'SIGINT or 'SIGBREAK did not seem affect the subprocess at all.

Using "(w32-start-process-share-console t)" with 'SIGHUP seemed to work
without triggering the abort dialog, and killing emacs with async
processes running also did, not trigger the aborts.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 20 Feb 2021 12:54:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 07:54:43 2021
Received: from localhost ([127.0.0.1]:51213 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDRmU-0000LH-J4
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 07:54:43 -0500
Received: from eggs.gnu.org ([209.51.188.92]:44994)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lDRmR-0000Ks-NP
 for 46494 <at> debbugs.gnu.org; Sat, 20 Feb 2021 07:54:40 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42539)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lDRmM-0002xe-E7; Sat, 20 Feb 2021 07:54:34 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4646
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lDRmL-0005LD-Th; Sat, 20 Feb 2021 07:54:34 -0500
Date: Sat, 20 Feb 2021 14:54:16 +0200
Message-Id: <83wnv2zypz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <868s7jym8t.fsf@HIDDEN> (message from Andy Moreton on Sat, 20
 Feb 2021 12:09:06 +0000)
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN> <868s7jym8t.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Sat, 20 Feb 2021 12:09:06 +0000
> 
> >   M-: (signal-process PROC-ID 'SIGHUP) RET
> >
> > (where PROC-ID is the process ID of the Emacs subprocess running the
> > native compilation), do you see the same crash, or does the subprocess
> > exit cleanly?  To see the PROC-ID, you can use the Task manager or the
> > 'pslist' command from the PsTools suite.
> 
> I tried that by adding binding this to a key:
>   (defun signal-hup (proc)
>     (interactive "nProcess: ")
>     (signal-process proc 'SIGHUP))
> 
> On a x86_64-w64-mingw32 build, sending SIGHUP to a compilation
> subprocess results in the emacs abort dialog being shown briefly and
> then disappearing (without user interaction). That dialog should require
> pressing a button to dismiss it.

I think if the process dies or exits, the dialog is closed.

So, since you seem to be able to reproduce this with a simpler setup,
please try these:

  . repeat the experiment using 'SIGINT and 'SIGBREAK instead of
    'SIGHUP
  . repeat the experiment with w32-start-process-share-console set to
    a non-nil value (both with SIGHUP and the other 2 SIG* signals)

I'd be interested to know whether the results are different.

(If you have no time for these experiments, just leave this until I
get to testing the branch.  TIA.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Feb 2021 12:09:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 07:09:20 2021
Received: from localhost ([127.0.0.1]:51162 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDR4a-0003Wn-17
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 07:09:20 -0500
Received: from lists.gnu.org ([209.51.188.17]:56284)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDR4Y-0003We-2A
 for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 07:09:18 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:54384)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDR4X-0007uK-UD
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 07:09:17 -0500
Received: from ciao.gmane.io ([116.202.254.214]:52682)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDR4W-00087H-IG
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 07:09:17 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lDR4T-0007Qp-VZ
 for bug-gnu-emacs@HIDDEN; Sat, 20 Feb 2021 13:09:13 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
Date: Sat, 20 Feb 2021 12:09:06 +0000
Message-ID: <868s7jym8t.fsf@HIDDEN>
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN> <834ki710ug.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:mZiSW/hyWsVYN3giuGH7/jwts4Q=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sat 20 Feb 2021, Eli Zaretskii wrote:

> OK, I've reviewed the code which kills subprocesses when Emacs is shut
> down, and I have some questions:
>
>   . How does libgccjit handle the case that its process is exiting?
>     Does it have any atexit handlers or static destructors?  IOW, how
>     does it ensure its own subprocesses, like gas etc. are terminated?
>
>   . When we invoke Emacs in a subprocess to do the async compilation,
>     do we specify that it should be killed without query?  I don't see
>     this in the code (did I miss it?), but if we don't, then exiting
>     Emacs will ask the user whether to kill the subprocesses -- does
>     it?
>
> Andy, if instead if exiting Emacs, you use signal-process, like this:
>
>   M-: (signal-process PROC-ID 'SIGHUP) RET
>
> (where PROC-ID is the process ID of the Emacs subprocess running the
> native compilation), do you see the same crash, or does the subprocess
> exit cleanly?  To see the PROC-ID, you can use the Task manager or the
> 'pslist' command from the PsTools suite.

I tried that by adding binding this to a key:
  (defun signal-hup (proc)
    (interactive "nProcess: ")
    (signal-process proc 'SIGHUP))

On a x86_64-w64-mingw32 build, sending SIGHUP to a compilation
subprocess results in the emacs abort dialog being shown briefly and
then disappearing (without user interaction). That dialog should require
pressing a button to dismiss it.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 20 Feb 2021 10:38:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 20 05:38:12 2021
Received: from localhost ([127.0.0.1]:51059 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lDPeO-0000aB-Cl
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2021 05:38:12 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50024)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lDPeL-0000Zv-Kr
 for 46494 <at> debbugs.gnu.org; Sat, 20 Feb 2021 05:38:11 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41553)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lDPeF-0001br-3x; Sat, 20 Feb 2021 05:38:03 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4006
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lDPeE-0000gM-CX; Sat, 20 Feb 2021 05:38:02 -0500
Date: Sat, 20 Feb 2021 12:37:43 +0200
Message-Id: <834ki710ug.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf8s7qv70t.fsf@HIDDEN> (message from Andrea Corallo on Sun, 14
 Feb 2021 18:28:02 +0000)
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN> <xjf8s7qv70t.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
> Date: Sun, 14 Feb 2021 18:28:02 +0000
> 
> >> > c) Quitting emacs when async compilation processes are running sometimes
> >> >    causes crashes in the compile processes, which show the emacs abort
> >> >    dialog (once for each async process). The dialogs disappear after a
> >> >    short delay (presumably due to the parent emacs having exited).
> >> 
> >> Mmmh, I guess this is a Windows specific behavior.  Is there a specific
> >> way to shut-down child processes we would use on Windows not to get
> >> this error?
> >
> > Andrea, can you point me to the place where we interrupt async
> > compilations when Emacs exits?  Is that just a normal delete-process,
> > or do we do something else, like sending a signal?  Also, does the
> > Emacs subprocess invoked to perform async compilation spawn further
> > child processes, or is everything happening inside a single Emacs
> > process?
> 
> Hi Eli,
> 
> we have no special handling for closing async compilation processes,
> they should be closed as all child processes started by Emacs are.
> 
> In the child process we do not spawn directly any other process, but
> libgccjit might do it (ex to call gas).

OK, I've reviewed the code which kills subprocesses when Emacs is shut
down, and I have some questions:

  . How does libgccjit handle the case that its process is exiting?
    Does it have any atexit handlers or static destructors?  IOW, how
    does it ensure its own subprocesses, like gas etc. are terminated?

  . When we invoke Emacs in a subprocess to do the async compilation,
    do we specify that it should be killed without query?  I don't see
    this in the code (did I miss it?), but if we don't, then exiting
    Emacs will ask the user whether to kill the subprocesses -- does
    it?

Andy, if instead if exiting Emacs, you use signal-process, like this:

  M-: (signal-process PROC-ID 'SIGHUP) RET

(where PROC-ID is the process ID of the Emacs subprocess running the
native compilation), do you see the same crash, or does the subprocess
exit cleanly?  To see the PROC-ID, you can use the Task manager or the
'pslist' command from the PsTools suite.

Thanks.

P.S. Andrea, I see you use "path" in comp.el (and perhaps elsewhere)
to mean "file name", but the GNU Coding Standards frown on using this
for anything other than PATH-style directory lists.  So this should at
some point be replaced with "file name".




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 14 Feb 2021 19:12:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 14:12:01 2021
Received: from localhost ([127.0.0.1]:36745 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBMoL-0004I0-G7
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 14:12:01 -0500
Received: from eggs.gnu.org ([209.51.188.92]:60408)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lBMoJ-0004Hi-Tz
 for 46494 <at> debbugs.gnu.org; Sun, 14 Feb 2021 14:12:00 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43469)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lBMoE-0004IX-Nv; Sun, 14 Feb 2021 14:11:54 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1878
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lBMoD-0002Vr-K5; Sun, 14 Feb 2021 14:11:54 -0500
Date: Sun, 14 Feb 2021 21:11:55 +0200
Message-Id: <834kiebh1g.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjf8s7qv70t.fsf@HIDDEN> (message from Andrea Corallo on Sun, 14
 Feb 2021 18:28:02 +0000)
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
 <xjf8s7qv70t.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
> Date: Sun, 14 Feb 2021 18:28:02 +0000
> 
> we have no special handling for closing async compilation processes,
> they should be closed as all child processes started by Emacs are.
> 
> In the child process we do not spawn directly any other process, but
> libgccjit might do it (ex to call gas).

OK, I will take a look.  Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 14 Feb 2021 18:28:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 13:28:08 2021
Received: from localhost ([127.0.0.1]:36679 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBM7s-0003B5-6b
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 13:28:08 -0500
Received: from mx.sdf.org ([205.166.94.24]:63896)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lBM7p-0003At-Ur
 for 46494 <at> debbugs.gnu.org; Sun, 14 Feb 2021 13:28:06 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11EIS2tE004813
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 14 Feb 2021 18:28:03 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN> <83sg5ybr95.fsf@HIDDEN>
Date: Sun, 14 Feb 2021 18:28:02 +0000
In-Reply-To: <83sg5ybr95.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 14 Feb
 2021 17:31:18 +0200")
Message-ID: <xjf8s7qv70t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Cc: 46494 <at> debbugs.gnu.org
>> Date: Sun, 14 Feb 2021 08:01:59 +0000
>> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
>> 
>> > c) Quitting emacs when async compilation processes are running sometimes
>> >    causes crashes in the compile processes, which show the emacs abort
>> >    dialog (once for each async process). The dialogs disappear after a
>> >    short delay (presumably due to the parent emacs having exited).
>> 
>> Mmmh, I guess this is a Windows specific behavior.  Is there a specific
>> way to shut-down child processes we would use on Windows not to get
>> this error?
>
> Andrea, can you point me to the place where we interrupt async
> compilations when Emacs exits?  Is that just a normal delete-process,
> or do we do something else, like sending a signal?  Also, does the
> Emacs subprocess invoked to perform async compilation spawn further
> child processes, or is everything happening inside a single Emacs
> process?

Hi Eli,

we have no special handling for closing async compilation processes,
they should be closed as all child processes started by Emacs are.

In the child process we do not spawn directly any other process, but
libgccjit might do it (ex to call gas).

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 14 Feb 2021 15:31:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 10:31:35 2021
Received: from localhost ([127.0.0.1]:36575 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBJN1-000588-C0
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 10:31:35 -0500
Received: from eggs.gnu.org ([209.51.188.92]:49008)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lBJMz-00057v-Rb
 for 46494 <at> debbugs.gnu.org; Sun, 14 Feb 2021 10:31:34 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39963)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lBJMp-0004bi-Df; Sun, 14 Feb 2021 10:31:23 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3781
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lBJMh-0003h6-EA; Sun, 14 Feb 2021 10:31:17 -0500
Date: Sun, 14 Feb 2021 17:31:18 +0200
Message-Id: <83sg5ybr95.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfft1zulfs.fsf@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <xjfft1zulfs.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: andrewjmoreton@HIDDEN, 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Cc: 46494 <at> debbugs.gnu.org
> Date: Sun, 14 Feb 2021 08:01:59 +0000
> From:  Andrea Corallo via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> > c) Quitting emacs when async compilation processes are running sometimes
> >    causes crashes in the compile processes, which show the emacs abort
> >    dialog (once for each async process). The dialogs disappear after a
> >    short delay (presumably due to the parent emacs having exited).
> 
> Mmmh, I guess this is a Windows specific behavior.  Is there a specific
> way to shut-down child processes we would use on Windows not to get
> this error?

Andrea, can you point me to the place where we interrupt async
compilations when Emacs exits?  Is that just a normal delete-process,
or do we do something else, like sending a signal?  Also, does the
Emacs subprocess invoked to perform async compilation spawn further
child processes, or is everything happening inside a single Emacs
process?

Armed with that knowledge, I will try to look at the code and figure
out why the compiling process crashes.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 14 Feb 2021 08:02:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 14 03:02:05 2021
Received: from localhost ([127.0.0.1]:35413 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lBCM0-0004S4-HZ
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2021 03:02:05 -0500
Received: from mx.sdf.org ([205.166.94.24]:54161)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lBCLw-0004Rd-7T
 for 46494 <at> debbugs.gnu.org; Sun, 14 Feb 2021 03:02:02 -0500
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 11E81x70021556
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Sun, 14 Feb 2021 08:01:59 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46494: 28.0.50; [native-comp] Problems with async
 background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
Date: Sun, 14 Feb 2021 08:01:59 +0000
In-Reply-To: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN> (Andy Moreton's
 message of "Sat, 13 Feb 2021 16:58:11 +0000")
Message-ID: <xjfft1zulfs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46494
Cc: 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> Problems notes with async compile in native-comp branch on Windows:
>
> a) Bug #46256 describes problems with AOT compiled native-comp emacs not
>    finding prebuilt .eln files when built for mingw64 64bit on Windows.
>
>    As a result, emacs complains with an echo area warning for every .eln
>    file that it cannot find in the expected location.

Please lets discuss each bug in each own thread, there's no need to use
more then one place.

>    The stream of frequent warnings that causes make emacs mostly
>    unresponsive to user input.

You can set `comp-async-report-warnings-errors' to nil if the packages
you use have to many compilation warnings.

For the motivation on reporting these warnings and more please see
bug#44746.

> b) The "background" async compilation of .eln files is CPU intensive and
>    somewhat slow. The default settings run a compile on every available
>    core, which is unfriendly for other workloads running on the same
>    machine.

The default setting ATM should be to run on half of the cores (see
`comp-effective-async-max-jobs'), if that's not the case on Windows
should be fixed.

>    It would be helpful to users to have a command to show the state of
>    the async background compilation, including the running compile
>    processes and the queue of pending compilation requests.

M-x list-processes
M: comp-files-queue

Ideally would be nicer to have a dedicated way to present the async
compilation status, but this does the job (for me at least).

> c) Quitting emacs when async compilation processes are running sometimes
>    causes crashes in the compile processes, which show the emacs abort
>    dialog (once for each async process). The dialogs disappear after a
>    short delay (presumably due to the parent emacs having exited).

Mmmh, I guess this is a Windows specific behavior.  Is there a specific
way to shut-down child processes we would use on Windows not to get
this error?

Thanks

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 13 Feb 2021 20:24:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 15:24:18 2021
Received: from localhost ([127.0.0.1]:35122 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lB1Sj-0004O6-VC
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:24:18 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50618)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lB1Si-0004Nu-DQ
 for 46494 <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:24:16 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56987)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lB1Sd-0002SX-6Q; Sat, 13 Feb 2021 15:24:11 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4716
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lB1Sc-0000lb-Iy; Sat, 13 Feb 2021 15:24:10 -0500
Date: Sat, 13 Feb 2021 22:24:08 +0200
Message-Id: <83zh07btsn.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <86czx3iush.fsf@HIDDEN> (message from Andy Moreton on Sat, 13
 Feb 2021 20:20:46 +0000)
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <834kifdeh9.fsf@HIDDEN> <86czx3iush.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Sat, 13 Feb 2021 20:20:46 +0000
> 
> >> c) Quitting emacs when async compilation processes are running sometimes
> >>     causes crashes in the compile processes, which show the emacs abort
> >>     dialog (once for each async process). The dialogs disappear after a
> >>     short delay (presumably due to the parent emacs having exited).
> >
> > Do the crashing processes run Emacs or do they run the compiler?  If
> > the former, can you attach GDB to them and show backtraces?
> 
> I think it is the compiler processes: I get multiple emacs abort dialogs
> rather than just one. I've tried attaching gdb, which does not manage to
> produce a backtrace.

I think it's Emacs that crashes, because otherwise why is the Emacs
abort di1alog shown?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Feb 2021 20:20:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 15:20:59 2021
Received: from localhost ([127.0.0.1]:35114 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lB1PX-0004IX-4F
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:20:59 -0500
Received: from lists.gnu.org ([209.51.188.17]:42726)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lB1PV-0004IP-1i
 for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 15:20:57 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:39230)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lB1PU-0007aG-TH
 for bug-gnu-emacs@HIDDEN; Sat, 13 Feb 2021 15:20:56 -0500
Received: from ciao.gmane.io ([116.202.254.214]:47998)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lB1PT-00024S-KX
 for bug-gnu-emacs@HIDDEN; Sat, 13 Feb 2021 15:20:56 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lB1PQ-0004Jt-39
 for bug-gnu-emacs@HIDDEN; Sat, 13 Feb 2021 21:20:52 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
Date: Sat, 13 Feb 2021 20:20:46 +0000
Message-ID: <86czx3iush.fsf@HIDDEN>
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
 <834kifdeh9.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:D3B8F68UXAIF5C7ZYv3fkeQnTPI=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Sat 13 Feb 2021, Eli Zaretskii wrote:

>> From: Andy Moreton <andrewjmoreton@HIDDEN>
>> Date: Sat, 13 Feb 2021 16:58:11 +0000
>> 
>> c) Quitting emacs when async compilation processes are running sometimes
>>     causes crashes in the compile processes, which show the emacs abort
>>     dialog (once for each async process). The dialogs disappear after a
>>     short delay (presumably due to the parent emacs having exited).
>
> Do the crashing processes run Emacs or do they run the compiler?  If
> the former, can you attach GDB to them and show backtraces?

I think it is the compiler processes: I get multiple emacs abort dialogs
rather than just one. I've tried attaching gdb, which does not manage to
produce a backtrace.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at 46494 <at> debbugs.gnu.org:


Received: (at 46494) by debbugs.gnu.org; 13 Feb 2021 18:12:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 13:12:12 2021
Received: from localhost ([127.0.0.1]:35006 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAzOt-0001D3-Qc
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 13:12:12 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52782)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lAzOr-0001Cp-Pw
 for 46494 <at> debbugs.gnu.org; Sat, 13 Feb 2021 13:12:10 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54459)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lAzOl-0002eU-VK; Sat, 13 Feb 2021 13:12:04 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4532
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lAzOk-0002sP-IA; Sat, 13 Feb 2021 13:12:03 -0500
Date: Sat, 13 Feb 2021 20:12:02 +0200
Message-Id: <834kifdeh9.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andy Moreton <andrewjmoreton@HIDDEN>
In-Reply-To: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN> (message from
 Andy Moreton on Sat, 13 Feb 2021 16:58:11 +0000)
Subject: Re: bug#46494: 28.0.50;
 [native-comp] Problems with async background compile
References: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46494
Cc: 46494 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Andy Moreton <andrewjmoreton@HIDDEN>
> Date: Sat, 13 Feb 2021 16:58:11 +0000
> 
> c) Quitting emacs when async compilation processes are running sometimes
>     causes crashes in the compile processes, which show the emacs abort
>     dialog (once for each async process). The dialogs disappear after a
>     short delay (presumably due to the parent emacs having exited).

Do the crashing processes run Emacs or do they run the compiler?  If
the former, can you attach GDB to them and show backtraces?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Feb 2021 16:58:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 11:58:20 2021
Received: from localhost ([127.0.0.1]:34968 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lAyFP-0007sA-TR
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 11:58:20 -0500
Received: from lists.gnu.org ([209.51.188.17]:53892)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrewjmoreton@HIDDEN>) id 1lAyFO-0007s2-KK
 for submit <at> debbugs.gnu.org; Sat, 13 Feb 2021 11:58:18 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:59416)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <andrewjmoreton@HIDDEN>)
 id 1lAyFO-0001lx-BA
 for bug-gnu-emacs@HIDDEN; Sat, 13 Feb 2021 11:58:18 -0500
Received: from mail-ed1-x530.google.com ([2a00:1450:4864:20::530]:40277)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <andrewjmoreton@HIDDEN>)
 id 1lAyFM-0005hT-Lg
 for bug-gnu-emacs@HIDDEN; Sat, 13 Feb 2021 11:58:18 -0500
Received: by mail-ed1-x530.google.com with SMTP id q10so3467545edt.7
 for <bug-gnu-emacs@HIDDEN>; Sat, 13 Feb 2021 08:58:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=to:subject:from:message-id:date:user-agent:mime-version
 :content-language:content-transfer-encoding;
 bh=MSsvjSbaa7kbjgRf29ESHK6tkwMS09wCUCHRwWWtz2s=;
 b=RVktB3U07jeQdxkb6FbLDlexxNWBdX7rukurjZZiomMD/GTB4pHZeT0pXn5zSWC7nX
 Ftx0pXtZYEYmZIkwtGflqwtYGsMvuNWYqzd+BBBBwfwQ8Gawxv4GeGzlA5eTkxKadmyX
 yYe1ZID9bavUGy/anWYUerruTO7jLc0pAGeTTt1i6AnoMrtW3omFq4b+wlcmrH2Be+/9
 jIZPSRdKC866CdkqQJ1OZ4sNLbxp8j5PI+1KXri+Xy+vrsOflZjj9fs07ad4R9x6SvXZ
 od0UYkMWjvLmh0VHzlDGBbl2gDtbEzyQucoP0RBo4gtfZDPZb5AAvKDJaV/o0i/F/Wba
 xixA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:to:subject:from:message-id:date:user-agent
 :mime-version:content-language:content-transfer-encoding;
 bh=MSsvjSbaa7kbjgRf29ESHK6tkwMS09wCUCHRwWWtz2s=;
 b=dtWbcblFAPr2rvuDCXi+2jVXTzIbM4mJ26MzyJkU+wETM0r6dlpktdCwJ8a9ZRrzrA
 BZlYuybWRXLOTEISMjhEbSt+cvEbL1XfZUOnuceD780cE3jErze8hwDZndxMld7Hp27/
 O1ZPAbCe8QNcSeaLZc6jp5hjydQTs17CQ4iQk5qNKP/EkHtZVH0+1ln9zyrKEgnmp6h6
 LfUIXnuc3ZCNoFB5CQnqcdtAbuuxuVKVtdmctnOGa9x7k1eUjv+CBwmpsNvsncl5a4++
 VyhVy8KJ5NY8YECQAzt7ERZnnAt8hQ6UJtAaUbNxeSw3R2i7jp65LWMRtvd/FZoP4z/w
 +kQg==
X-Gm-Message-State: AOAM530M2HEtuxT39mJeQf36kiqZmnkS47aSPqr6PWJAkEYPR+PebhNg
 Fz+ELIPmsm9DlKw9ivS9jBTWMK4DCPo=
X-Google-Smtp-Source: ABdhPJwn3oTKEzxdvwAgaJ9ysnaeIu1euKh0x3uwqYL7764x1TBsJphsMaVtjP2REEmgauKZTsstDw==
X-Received: by 2002:aa7:c351:: with SMTP id j17mr8364763edr.261.1613235494800; 
 Sat, 13 Feb 2021 08:58:14 -0800 (PST)
Received: from [192.168.0.6] (82-69-64-228.dsl.in-addr.zen.co.uk.
 [82.69.64.228])
 by smtp.gmail.com with ESMTPSA id n6sm7800883ejy.123.2021.02.13.08.58.13
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Sat, 13 Feb 2021 08:58:14 -0800 (PST)
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; [native-comp] Problems with async background compile
From: Andy Moreton <andrewjmoreton@HIDDEN>
Message-ID: <52dad420-fd72-fe1c-6f74-f4c114a2deb8@HIDDEN>
Date: Sat, 13 Feb 2021 16:58:11 +0000
User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-GB
Content-Transfer-Encoding: 7bit
Received-SPF: pass client-ip=2a00:1450:4864:20::530;
 envelope-from=andrewjmoreton@HIDDEN; helo=mail-ed1-x530.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Problems notes with async compile in native-comp branch on Windows:

a) Bug #46256 describes problems with AOT compiled native-comp emacs not
    finding prebuilt .eln files when built for mingw64 64bit on Windows.

    As a result, emacs complains with an echo area warning for every .eln
    file that it cannot find in the expected location.

    The stream of frequent warnings that causes make emacs mostly
    unresponsive to user input.

b) The "background" async compilation of .eln files is CPU intensive and
    somewhat slow. The default settings run a compile on every available
    core, which is unfriendly for other workloads running on the same
    machine.

    It would be helpful to users to have a command to show the state of
    the async background compilation, including the running compile
    processes and the queue of pending compilation requests.

c) Quitting emacs when async compilation processes are running sometimes
    causes crashes in the compile processes, which show the emacs abort
    dialog (once for each async process). The dialogs disappear after a
    short delay (presumably due to the parent emacs having exited).







Acknowledgement sent to Andy Moreton <andrewjmoreton@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#46494; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 22 Feb 2021 20:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.